use std::env::var;

fn main() {
    let target_arch = var("CARGO_CFG_TARGET_ARCH").unwrap();
    let target_have_sse2 = var("CARGO_CFG_TARGET_FEATURE")
        .map_or(false, |features| {
            features.split(",").any(|feature| feature == "sse2")
        });
    let opt_level = var("OPT_LEVEL").unwrap_or_else(|_| "0".to_string());

    if &target_arch == "x86" && !target_have_sse2 && opt_level != "0" {
        println!("cargo:warning=Compiling optimized code on Debian non-SSE2 i686 architecture leads to unsound code. Build will be aborted.");
        std::process::exit(1);
    }
}
